/** @format */

module.exports = {
  parser: '@typescript-eslint/parser',
  extends: ['plugin:@typescript-eslint/recommended', 'prettier/@typescript-eslint', 'plugin:prettier/recommended'],
  plugins: ['@typescript-eslint'],
  rules: {
    'linebreak-style': ['error', 'unix'],
    indent: ['error', 2],
    quotes: [2, 'single', {allowTemplateLiterals: true}],
    semi: [2, 'always'],
    strict: 'off',
    curly: 2,
    eqeqeq: 2,
    'no-eval': 2,
    'guard-for-in': 2,
    'no-caller': 2,
    'no-else-return': 2,
    'no-eq-null': 2,
    'no-extend-native': 2,
    'no-extra-bind': 2,
    'no-floating-decimal': 2,
    'no-implied-eval': 2,
    'no-labels': 2,
    'no-with': 2,
    'no-loop-func': 1,
    'no-native-reassign': 2,
    'no-redeclare': [2, {builtinGlobals: true}],
    'no-delete-var': 2,
    'no-shadow-restricted-names': 2,
    'no-undef-init': 2,
    'no-use-before-define': 0,
    'no-unused-vars': [2, {args: 'none'}],
    'no-undef': 2,
    'callback-return': [1, ['callback', 'cb', 'next']],
    'global-require': 0,
    'no-console': 0,
    'require-yield': 0,
    'no-multi-spaces': 2,
    'block-spacing': 2,
    'keyword-spacing': 2,
    'space-before-blocks': 2,
    'no-process-exit': 1,
    'comma-spacing': 2,
    'key-spacing': 2,
    'comma-dangle': 2,
    'space-infix-ops': 2,
    'prefer-const': 'off',
    'no-var': 'off',
    'prefer-rest-params': 'off',
    '@typescript-eslint/no-var-requires': 'off',
    '@typescript-eslint/camelcase': 'off',
    '@typescript-eslint/no-empty-function': 'off',
    '@typescript-eslint/no-use-before-define': 'off',
    '@typescript-eslint/no-this-alias': 'off',
    '@typescript-eslint/explicit-function-return-type': 'off',
    '@typescript-eslint/no-unused-vars': 'off'
  },
  env: {
    es6: true,
    node: true,
    browser: true,
  },
  globals: {
    describe: true,
    it: true,
    before: true,
    after: true,
    beforeEach: true,
    afterEach: true
  },
  parserOptions: {
    ecmaVersion: 8,
    sourceType: 'module'
  }
};
