"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var i18n_1 = require("../../utils/i18n");
var delete_manager_1 = require("./delete-manager");
var config_error_1 = require("../../error/config-error");
var command_error_1 = require("../../error/command-error");
var description = i18n_1.default.__('s config delete help');
program
    .name('s config delete')
    .usage('[options] [name]')
    .helpOption('-h,--help', i18n_1.default.__('Display help for command'))
    .option('-p,  --provider [name]', i18n_1.default.__('The cloud service provider. [alibaba/aws/azure/baidu/google/huawei/tencent]'))
    .option('-a , --alias-name [name]', i18n_1.default.__('Key pair alia, if the alias is not set, use default instead'))
    .description(description)
    .parse(process.argv);
(function () { return __awaiter(void 0, void 0, void 0, function () {
    var providerAlias;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                providerAlias = {
                    Provider: program.provider,
                    AliasName: program.aliasName,
                };
                if (program.args.length === 0 && (program.provider == undefined || program.aliasName == undefined)) {
                    program.help();
                }
                else if (program.args.length > 0) {
                    throw new config_error_1.ConfigError('Please input right format , You can obtain the key information through: s config delete -h.');
                }
                return [4 /*yield*/, new delete_manager_1.DeleteManager().init(providerAlias)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); })().catch(function (err) {
    throw new command_error_1.CommandError(err.message);
});
//# sourceMappingURL=index.js.map