"use strict";
/** @format */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateManager = void 0;
var common_1 = require("../../utils/common");
var path = require('path');
var os = require('os');
var inquirer = require('inquirer');
var fs = require('fs');
var yaml = require('js-yaml');
var logger_1 = require("../../utils/logger");
var config_update_error_1 = require("../../error/config-update-error");
var common_2 = require("../common/common");
var i18n_1 = require("../../utils/i18n");
var UpdateManager = /** @class */ (function () {
    function UpdateManager() {
        this.promptList = [];
        this.oldSecretID = {};
        this.inputSecretData = {};
        this.userInformation = {};
        // 获得当前用户目录
        this.filePath = path.join(os.homedir(), '.s/access.yaml');
    }
    UpdateManager.prototype.updateManager = function (providerAlias, inputSecret) {
        return __awaiter(this, void 0, void 0, function () {
            var hasProviderAlia;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.userInformation = yaml.safeLoad(fs.readFileSync(this.filePath, 'utf8'));
                        if (!this.userInformation) return [3 /*break*/, 7];
                        if (!(providerAlias.Provider && providerAlias.AliasName)) return [3 /*break*/, 6];
                        this.provider = String(providerAlias.Provider).toLocaleLowerCase();
                        this.aliasName = String(providerAlias.AliasName).toLocaleLowerCase();
                        this.inputProviderAlias = this.provider + "." + (this.aliasName || 'default');
                        hasProviderAlia = Object.keys(this.userInformation).includes(this.inputProviderAlias);
                        if (!hasProviderAlia) return [3 /*break*/, 5];
                        if (!(Object.keys(inputSecret).length === 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.inputSecretZero(providerAlias)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.inputSecretNotZero(inputSecret)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5: throw new config_update_error_1.ConfigUpdateError('The provider or alias information is not found. You can obtain the key information through: s config get -l');
                    case 6: return [3 /*break*/, 8];
                    case 7: throw new config_update_error_1.ConfigUpdateError('The configuration list is empty. You can add configuration through: s config add');
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    UpdateManager.prototype.inputSecretZero = function (providerAlias) {
        return __awaiter(this, void 0, void 0, function () {
            var tempAccess, hiddenMapping, i, tempName, valueOfValueLength, oldValue;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        try {
                            Object.keys(common_2.providerCollection).forEach(function (item) {
                                if (item === _this.provider) {
                                    _this.promptList = common_2.providerCollection[item];
                                }
                            });
                        }
                        catch (err) {
                            throw new config_update_error_1.ConfigUpdateError(err.message);
                        }
                        tempAccess = __assign({}, this.userInformation[providerAlias.Provider + "." + (providerAlias.AliasName || 'default')]);
                        hiddenMapping = {};
                        for (i = 0; i < this.promptList.length; i++) {
                            tempName = this.promptList[i].name;
                            valueOfValueLength = tempAccess[tempName].length;
                            oldValue = tempAccess[tempName];
                            tempAccess[tempName] =
                                valueOfValueLength > 6
                                    ? tempAccess[tempName].slice(0, 3) +
                                        common_1.printn(valueOfValueLength - 6, '*') +
                                        tempAccess[tempName].slice(valueOfValueLength - 3, valueOfValueLength)
                                    : tempAccess[tempName];
                            hiddenMapping[tempAccess[tempName]] = oldValue;
                            this.promptList[i].default = tempAccess[tempName];
                        }
                        return [4 /*yield*/, inquirer.prompt(this.promptList).then(function (answers) {
                                _this.inputSecretData = answers;
                            })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.userInputCheck(this.inputSecretData, hiddenMapping)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    UpdateManager.prototype.inputSecretNotZero = function (inputSecret) {
        return __awaiter(this, void 0, void 0, function () {
            var hasProviderAlia;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        hasProviderAlia = Object.keys(this.userInformation).includes(this.inputProviderAlias);
                        if (!hasProviderAlia) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.userInputCheck(inputSecret)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    // 校验用户输入的信息, 并更新用户信息
    UpdateManager.prototype.userInputCheck = function (inputSecret, hiddenMapping) {
        return __awaiter(this, void 0, void 0, function () {
            var providerAccessFormatSecret;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        providerAccessFormatSecret = common_2.providerAccessFormat[this.provider];
                        this.oldSecretID = this.userInformation[this.inputProviderAlias];
                        Object.keys(inputSecret).forEach(function (item) {
                            if (!providerAccessFormatSecret.includes(item)) {
                                throw new config_update_error_1.ConfigUpdateError('Please Input Right Secret Format: [{{providerAccessFormatSecret}}]', {
                                    providerAccessFormatSecret: providerAccessFormatSecret,
                                });
                            }
                            else if (providerAccessFormatSecret.includes(item) && inputSecret[item]) {
                                var value = inputSecret[item];
                                if (hiddenMapping && hiddenMapping[value]) {
                                    value = hiddenMapping[value];
                                }
                                _this.oldSecretID[item] = value;
                            }
                        });
                        this.userInformation[this.inputProviderAlias] = this.oldSecretID;
                        return [4 /*yield*/, this.writeFileWay(this.filePath, this.userInformation)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    UpdateManager.prototype.writeFileWay = function (filePath, text) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, fs.writeFileSync(filePath, yaml.dump(text))];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        throw new config_update_error_1.ConfigUpdateError(err_1.message);
                    case 3:
                        logger_1.default.success('Update succeeded.');
                        return [2 /*return*/];
                }
            });
        });
    };
    UpdateManager.prototype.output = function () {
        logger_1.default.log('');
        logger_1.default.info(i18n_1.default.__('  Provider: {{provider}}', { provider: common_2.providerObject[this.provider] + "(" + this.provider + ")" }));
        if (this.aliasName) {
            logger_1.default.info(i18n_1.default.__('    Alias: {{alias}}', { alias: this.aliasName }));
        }
        for (var item in this.oldSecretID) {
            logger_1.default.info("    " + item + ": " + this.oldSecretID[item]);
        }
        logger_1.default.log('');
    };
    return UpdateManager;
}());
exports.UpdateManager = UpdateManager;
//# sourceMappingURL=update-manager.js.map