"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rimraf = require('rimraf');
var path = require('path');
var os = require('os');
var fs = require('fs');
var execSync = require('child_process').execSync;
var got = require('got');
var decompress = require('decompress');
var decompressUnzip = require('decompress-unzip');
var download = require("download");
var axios_1 = require("axios");
var logger = require("../utils/logger");
var i18n_1 = require("../utils/i18n");
var handler_set_config_1 = require("../utils/handler-set-config");
var static_variable_1 = require("../constants/static-variable");
var s_progress_bar_1 = require("@serverless-devs/s-progress-bar");
var colors_1 = require("colors");
var S_GUI_BASE_PATH = path.join(os.homedir(), ".s/client");
var GUIService = /** @class */ (function () {
    function GUIService(guiPath) {
        if (guiPath === void 0) { guiPath = '/'; }
        if (!fs.existsSync(S_GUI_BASE_PATH)) {
            fs.mkdirSync(S_GUI_BASE_PATH);
        }
        process.env.GUIPATH = guiPath;
    }
    GUIService.prototype.getOsType = function () {
        var platform = process.platform;
        var osType = 'macos';
        switch (platform) {
            case 'darwin':
                osType = 'macos';
                break;
            case 'win32':
                osType = 'windows';
                break;
            default:
                osType = 'linux';
                break;
        }
        return osType;
    };
    GUIService.prototype.getGuiAppInfo = function (osType) {
        if (osType === 'macos') {
            return path.join(S_GUI_BASE_PATH, 'serverless-devs-tool-client-macos.app');
        }
        if (osType === 'windows') {
            return path.join(S_GUI_BASE_PATH, 'serverless-devs-tool-client-windows', 's.exe');
        }
        // if (osType === 'linux') {
        //   return path.join(S_GUI_BASE_PATH, 's');
        // }
    };
    GUIService.prototype.downloadAndExcuteGui = function (osType) {
        return __awaiter(this, void 0, void 0, function () {
            var result, data, url, downloadPath, len, headers, err_1, bar_1, pbo, pbo, format, tmpZipFile, pbo, format, newBar_1, timmer, appInfo, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default.get(static_variable_1.SERVERLESS_GUI_CLIENT_VERSION_CHECK)];
                    case 1:
                        result = _a.sent();
                        data = result.data || [];
                        if (!data[0]) return [3 /*break*/, 11];
                        logger.info("Current system : " + osType + ", current client version: " + data[0].version + " ");
                        url = data[0].url || {};
                        if (!url[osType]) return [3 /*break*/, 11];
                        downloadPath = url[osType];
                        len = void 0;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, got(downloadPath, { method: 'HEAD' })];
                    case 3:
                        headers = (_a.sent()).headers;
                        len = parseInt(headers['content-length'], 10);
                        return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        return [3 /*break*/, 5];
                    case 5:
                        if (len) {
                            pbo = {
                                total: len,
                            };
                            bar_1 = new s_progress_bar_1.ProgressService(s_progress_bar_1.ProgressType.Bar, pbo);
                        }
                        else {
                            pbo = {
                                total: 100,
                                width: 0,
                            };
                            format = colors_1.green(':loading') + " " + colors_1.green(i18n_1.default.__('Downloading ...')) + " ";
                            bar_1 = new s_progress_bar_1.ProgressService(s_progress_bar_1.ProgressType.Loading, pbo, format);
                        }
                        return [4 /*yield*/, download(downloadPath, S_GUI_BASE_PATH).on('downloadProgress', function (progress) {
                                bar_1.update(progress.transferred);
                            })];
                    case 6:
                        _a.sent();
                        bar_1.terminate();
                        logger.success('Download successfully, now start to unzip.');
                        _a.label = 7;
                    case 7:
                        _a.trys.push([7, 10, , 11]);
                        tmpZipFile = path.join(S_GUI_BASE_PATH, "serverless-devs-tool-client-" + osType + ".zip");
                        pbo = {
                            total: 100,
                            width: 0,
                        };
                        format = colors_1.green(i18n_1.default.__(':loading')) + " " + colors_1.green(i18n_1.default.__('Unziping ...')) + " ";
                        newBar_1 = new s_progress_bar_1.ProgressService(s_progress_bar_1.ProgressType.Loading, pbo, format);
                        timmer = setInterval(function () {
                            newBar_1.update();
                        }, 500);
                        return [4 /*yield*/, decompress(tmpZipFile, S_GUI_BASE_PATH, {
                                plugins: [decompressUnzip()],
                            })];
                    case 8:
                        _a.sent();
                        clearInterval(timmer);
                        newBar_1.terminate();
                        logger.success('Unzip success begin to start.');
                        appInfo = this.getGuiAppInfo(osType);
                        return [4 /*yield*/, this.setVersion(data[0].version)];
                    case 9:
                        _a.sent();
                        this.open(appInfo);
                        fs.unlinkSync(tmpZipFile);
                        return [3 /*break*/, 11];
                    case 10:
                        e_1 = _a.sent();
                        logger.error(e_1.message);
                        return [3 /*break*/, 11];
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    GUIService.prototype.open = function (appInfo) {
        var startInstruction = process.platform === 'win32' ? 'start' : 'open';
        execSync(startInstruction + " " + appInfo + " ");
    };
    GUIService.prototype.start = function (update) {
        return __awaiter(this, void 0, void 0, function () {
            var osType, appInfo, versions, lang, data, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        osType = this.getOsType();
                        appInfo = this.getGuiAppInfo(osType);
                        return [4 /*yield*/, this.getVersionResult()];
                    case 1:
                        versions = _a.sent();
                        if (!(!fs.existsSync(appInfo) || update === true)) return [3 /*break*/, 6];
                        if (!(update === true)) return [3 /*break*/, 3];
                        logger.info('GUI updating ......');
                        return [4 /*yield*/, rimraf(appInfo, function (err) {
                                // 删除当前目录下的 aaa
                                if (err) {
                                    logger.error(err);
                                }
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        logger.info('Check that you don’t have a gui client, download it now, it will take you about 1 minute.');
                        _a.label = 4;
                    case 4: return [4 /*yield*/, this.downloadAndExcuteGui(osType)];
                    case 5:
                        _a.sent();
                        return [2 /*return*/];
                    case 6:
                        if (!(versions !== undefined && versions[0] !== versions[1])) return [3 /*break*/, 10];
                        logger.info('The system has detected a new version of the GUI. You can use `s gui --update` to upgrade.');
                        _a.label = 7;
                    case 7:
                        _a.trys.push([7, 9, , 10]);
                        return [4 /*yield*/, handler_set_config_1.handlerProfileFile({ read: true, filePath: 'set-config.yml' })];
                    case 8:
                        lang = (_a.sent()).locale || 'en';
                        logger.log('\n');
                        logger.log('    Update information:');
                        data = versions[2][lang] || versions[2];
                        data.forEach(function (message, index) {
                            logger.log("        " + (index + 1) + ". " + message);
                        });
                        logger.log('\n');
                        return [3 /*break*/, 10];
                    case 9:
                        err_2 = _a.sent();
                        return [3 /*break*/, 10];
                    case 10:
                        this.open(appInfo);
                        return [2 /*return*/];
                }
            });
        });
    };
    GUIService.prototype.getVersionResult = function () {
        return __awaiter(this, void 0, void 0, function () {
            var profile, localVersion, result, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, handler_set_config_1.handlerProfileFile({ read: true, filePath: 'cache.yml' })];
                    case 1:
                        profile = _a.sent();
                        localVersion = profile['app-store-client-version'];
                        return [4 /*yield*/, axios_1.default.get(static_variable_1.SERVERLESS_GUI_CLIENT_VERSION_CHECK)];
                    case 2:
                        result = _a.sent();
                        data = result.data || [];
                        return [2 /*return*/, data.length === 0 ? undefined : [localVersion, data[0].version, data[0].message]];
                }
            });
        });
    };
    GUIService.prototype.setVersion = function (version) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, handler_set_config_1.handlerProfileFile({
                            data: version,
                            configKey: 'app-store-client-version',
                            filePath: 'cache.yml',
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return GUIService;
}());
exports.default = GUIService;
//# sourceMappingURL=gui-service.js.map