"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var i18n_1 = require("../utils/i18n");
// import * as msg from './init-message';
var init_manager_1 = require("./init-manager");
var command_error_1 = require("../error/command-error");
var gui_service_1 = require("../gui/gui-service");
var description = i18n_1.default.__('Initialize a new project based on a template.') + "\n\n    " + i18n_1.default.__('Example:') + "\n        $ s init\n        $ s init project\n        $ s init git@github.com:foo/bar.git\n        $ s init https://github.com/foo/bar.git\n    \n    " + i18n_1.default.__('You could get a project from Serverless Devs App Store. Like:') + "\n        $ s search keywords\n        $ s search --gui\n        $ s init --gui\n    ";
program
    .name('s init')
    .helpOption('-h, --help', i18n_1.default.__('Display help for command'))
    .usage('[options] [name | url]')
    .option('-p, --provider [provider]', i18n_1.default.__('The cloud service provider'))
    .option('-d, --dir [dir]', i18n_1.default.__('Where to output the initialized app into (default: ./ )'))
    .option('-g, --gui', i18n_1.default.__('Init project through GUI service'))
    .description(description)
    .parse(process.argv);
(function () { return __awaiter(void 0, void 0, void 0, function () {
    var gui, guiService, initManager, target, provider, dir;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                gui = program.gui || false;
                if (program.args.length === 0 && gui === false) {
                    program.help();
                    return [2 /*return*/];
                    // throw new ServerlessError(msg.initPopUpTips);
                }
                if (!(gui === true)) return [3 /*break*/, 2];
                guiService = new gui_service_1.default();
                return [4 /*yield*/, guiService.start()];
            case 1:
                _a.sent();
                return [3 /*break*/, 4];
            case 2:
                initManager = new init_manager_1.InitManager();
                target = program.args[0];
                provider = program.provider;
                dir = program.dir;
                return [4 /*yield*/, initManager.init(target, provider, dir)];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); })().catch(function (err) {
    throw new command_error_1.CommandError(err.message);
});
//# sourceMappingURL=init.js.map