"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlatformPublishManager = void 0;
var axios_1 = require("axios");
var platform_publish_error_1 = require("../../error/platform-publish-error");
var logger_1 = require("../../utils/logger");
var path = require("path");
var os = require("os");
var Zip = require('adm-zip');
var static_variable_1 = require("../../constants/static-variable");
var PlatformPublishManager = /** @class */ (function () {
    function PlatformPublishManager() {
    }
    PlatformPublishManager.prototype.publish = function (user, content, readme) {
        return __awaiter(this, void 0, void 0, function () {
            var zipFile, zipper, result, url, options, uploadResult, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        logger_1.default.info('Publishing......');
                        zipFile = path.join(os.tmpdir(), this.generateUUID() + '.zip');
                        zipper = new Zip();
                        zipper.addLocalFolder('src', 'src');
                        zipper.writeZip(zipFile);
                        return [4 /*yield*/, axios_1.default.post(static_variable_1.SERVERLESS_PUBLISH_PACKAGE_URL, {
                                user: user,
                                publish: content,
                                readme: readme,
                            })];
                    case 1:
                        result = _a.sent();
                        // eslint-disable-next-line eqeqeq
                        if (result.status != 200) {
                            throw new Error("Failed to publish package, http status code: " + result.status);
                        }
                        if (result.data.Error) {
                            throw new Error("Failed to publish package, code: " + result.data.Error.Code + ", message: " + result.data.Error.Message);
                        }
                        url = result.data.Response.Url;
                        options = {
                            url: url,
                            method: 'put',
                            timeout: 30 * 60 * 1000,
                            headers: {},
                            data: zipper.toBuffer(),
                            maxContentLength: Infinity,
                            maxBodyLength: Infinity,
                            transformRequest: function (data, headers) {
                                delete headers.put;
                                return data;
                            },
                        };
                        return [4 /*yield*/, axios_1.default(options)];
                    case 2:
                        uploadResult = _a.sent();
                        // eslint-disable-next-line eqeqeq
                        if (uploadResult.status != 200) {
                            throw new Error("Failed to upload package, status code is: " + uploadResult.status + ", messge is : " + uploadResult);
                        }
                        logger_1.default.success('Publish successfully');
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        throw new platform_publish_error_1.PlatformPublishError(err_1.message);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    PlatformPublishManager.prototype.generateUUID = function () {
        return (Math.random()
            .toString(36)
            .substring(2, 15) +
            Math.random()
                .toString(36)
                .substring(2, 15));
    };
    return PlatformPublishManager;
}());
exports.PlatformPublishManager = PlatformPublishManager;
//# sourceMappingURL=platform-publish-manager.js.map