"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handlerProfileFile = exports.getConfig = exports.setConfig = void 0;
var os = require('os');
var fs = require('fs');
var path = require('path');
var yaml = require('js-yaml');
function setConfig(key, value) {
    var profile = getProfileFile();
    profile[key] = value;
    setProfileFile(profile);
}
exports.setConfig = setConfig;
function getConfig(key) {
    var profile = getProfileFile();
    return profile[key];
}
exports.getConfig = getConfig;
function handlerProfileFile(parame) {
    return __awaiter(this, void 0, void 0, function () {
        var filePath, profPath, isExists, profile, configDir, e_1, configKey;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    filePath = parame.filePath || 'set-config.yml';
                    profPath = path.join(os.homedir(), ".s/" + filePath);
                    isExists = fs.existsSync(profPath);
                    profile = {};
                    if (!!isExists) return [3 /*break*/, 5];
                    configDir = path.join(os.homedir(), '.s');
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 2, , 4]);
                    fs.statSync(configDir);
                    return [3 /*break*/, 4];
                case 2:
                    e_1 = _a.sent();
                    return [4 /*yield*/, fs.mkdirSync(configDir)];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 4: return [3 /*break*/, 6];
                case 5:
                    try {
                        profile = yaml.safeLoad(fs.readFileSync(profPath, 'utf8')) || {};
                    }
                    catch (e) {
                        throw e;
                    }
                    _a.label = 6;
                case 6:
                    // 如果仅是读取，则拿到配置信息直接退出
                    if (parame.read) {
                        return [2 /*return*/, profile];
                    }
                    configKey = parame.configKey || '';
                    profile[configKey] = parame.data;
                    return [4 /*yield*/, fs.writeFileSync(profPath, yaml.dump(profile))];
                case 7:
                    _a.sent();
                    return [2 /*return*/, profile];
            }
        });
    });
}
exports.handlerProfileFile = handlerProfileFile;
function setProfileFile(profile) {
    var profileFilePath = getDefaultProfilePath();
    fs.writeFileSync(profileFilePath, yaml.dump(profile));
}
function getProfileFile() {
    var profileFilePath = getDefaultProfilePath();
    if (!fs.existsSync(profileFilePath)) {
        return {};
    }
    try {
        return yaml.safeLoad(fs.readFileSync(profileFilePath, 'utf8')) || {};
    }
    catch (e) {
        throw e;
    }
}
function getDefaultProfilePath() {
    return path.join(os.homedir(), '.s', 'set-config.yml');
}
//# sourceMappingURL=handler-set-config.js.map